; how to derive an 8x12 or 8x24 font from 8x14
%ifndef twelve
%define twelve 1	; if 1, make 8x12, if 0, make 8x24
%endif

	org 100h
start:	; inflate 8x14 to 8x24 font
	mov ah,2	; set cursor position
	mov bh,0	; page
	mov dx,0	; home cursor
	int 10h

	mov ax,1130h	; get font pointer
	mov bh,2	; 8x14 please (6/7 is 8x16/9x16)
	int 10h		; vga
	; returns es:bp, also cx and dl

	cld
	push ds		; swap
	push es		; es
	pop ds		; and
	pop es		; ds
	mov di,myfont	; create font here
	mov si,bp	; ds:si -> rom font, es:di -> new font
	mov cx,256	; count

%if twelve		; squeeze first and last line into adjacent ones
copyme:	lodsb
	mov ah,al
	lodsb
	or al,ah
	stosb
	movsw		; now just copy the middle 10 lines
	movsw
	movsw
	movsw
	movsw
	lodsb
	mov ah,al
	lodsb
	or al,ah
	stosb
	loop copyme
%else
copyme:	movsw		; copy 2 lines
	mov bx,10	; scale next 10 lines into 20 lines
copy2:	lodsb
	stosb
	stosb
	dec bx
	jnz copy2
	movsw		; copy 2 lines
	loop copyme
%endif

	mov ax,1110h	; load user font (1100: w/o hardware fixup)
	push cs
	pop es
	mov bp,myfont	; es:bp pointer
	mov cx,256	; char count
	mov dx,0	; offset into font ram
	mov bl,0	; "block to load in map 2"
%if twelve
	mov bh,12
%else
	mov bh,24	; bytes / lines per char
%endif
	int 10h		; vga

	push cs
	pop es
	mov di,myfont	; do a simple "char table", too
	mov ax,32
fill:	cmp ax,"$"
	jz skip
	stosb
skip:	inc al
	jnz fill
	mov al,'$'
	stosb

	push cs
	pop ds
	mov ah,9	; show string
	mov dx,mymsg	; offset
	int 21h		; dos

	mov ax,4c00h	; exit with errorlevel 0
	int 21h		; dos

mymsg	db 13,10,"Hello 8x24 world :-)",13,10
myfont	db 0		; our new font will be created here
